﻿package com.axisstudios {
	
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.display.Sprite;
	import flash.display.BitmapData;
	import flash.filters.BitmapFilter;
	import flash.display.Bitmap;
	import flash.filters.BlurFilter;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.display.GradientType;
	import flash.display.SpreadMethod;
	import flash.display.BitmapDataChannel;
	import flash.filters.DisplacementMapFilter;
	import flash.filters.DisplacementMapFilterMode;
	import flash.filters.ColorMatrixFilter;
	
	/*import flash.display.BlendModeShader;
	import flash.display.shaders.*;
	import flash.display.BlendMode;
	import flash.display.Shader;*/
	
	
	
	/**
	 * @author	Jeffrey Blyseth
	 * 			Axis Studios
	 * 			jeffrey@axis-studios.com
	 * 			http://www.axis-studios.com
	 */

	public class HotSmoke extends Sprite {
		
		private static const SPEED:Number = .6;
		
		private var __canvas:Sprite = new Sprite();
		private var __canvasMatrix:Matrix = new Matrix();
		private var __displacementMap:Sprite = new Sprite();
		private var __displacementBmp:BitmapData;
		private var __displaceMatrix:Matrix = new Matrix();
		
		private var __canvas2:Sprite = new Sprite();
		private var __canvas2Matrix:Matrix = new Matrix();
		private var __displacement2Map:Sprite = new Sprite();
		private var __displacement2Bmp:BitmapData;
		private var __displace2Matrix:Matrix = new Matrix();
		
		private var __ySpeed:Number = SPEED;
		private var __yDirection:Number = 1;
		
		private var __width:Number;
		private var __wispWidth:Number;
		private var __height:Number;
		private var __displacementWaves:Number;
		private var __perlinBmpData:BitmapData;
		private var __mask:Sprite = new Sprite();
		private var __blurAmount:Number = 30;
		private var __dying:Boolean = false;
		private var __useMask:Boolean;
		private var __grad:Sprite;
		
		
		public function HotSmoke(w:Number, h:Number, dw:Number, useMask:Boolean = false) {
			__width = w+__blurAmount*2;
			__height = h+__blurAmount*2;
			x = y = -__blurAmount;
			__displacementWaves = dw;
			__useMask = useMask;
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		public function pause():void{
			try{
				removeEventListener(Event.ENTER_FRAME, update);
			}catch(e:Error){}
		}
		public function resume():void{
			try{
				addEventListener(Event.ENTER_FRAME, update);
			}catch(e:Error){}
		}
		private function init(evt:Event):void{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			var p:Point = new Point(0, 0);
			this.alpha = 0;
			// displacement
			var blurF:BlurFilter = new BlurFilter(__blurAmount, __blurAmount);
			__displaceMatrix.createGradientBox(__height/__displacementWaves, __height/__displacementWaves, 0, 0, 0);
			__displaceMatrix.rotate(Math.PI / 2);
			__displacementBmp = new BitmapData(__width*2, __height, true, 0);
			__displacementBmp.applyFilter(__displacementBmp, __displacementBmp.rect, p, blurF);
			
			__displace2Matrix.createGradientBox(__height/__displacementWaves, __height/__displacementWaves, 0, 0, 0);
			__displacement2Bmp = new BitmapData(__width, __height*2, true, 0);
			__displacement2Bmp.applyFilter(__displacementBmp, __displacementBmp.rect, p, blurF);
			
			var channels:uint        = BitmapDataChannel.RED;
			var componentX:uint      = channels;
			var componentY:uint      = channels;
			var scaleX:Number        = 50;
			var scaleY:Number        = 0.5;
			var mode:String          = DisplacementMapFilterMode.CLAMP;
			var color:uint           = 0;
			var alpha:Number         = 0;
			var f:BitmapFilter = new DisplacementMapFilter(__displacementBmp, p, componentX, componentY, scaleX, scaleY, mode, color, alpha);
			
			// steam
			__perlinBmpData = new BitmapData(stage.stageWidth, __height*4, true, 0xffffffff);
			__perlinBmpData.perlinNoise(100, 100, 8, 1000, true, false, 8, true, [p, p]);
			//__perlinBmpData.perlinNoise(100, 100, 4, 1000, true, false, 7, true, [p, p]);
			
			var b2:Number = __blurAmount*.7;
			blurF = new BlurFilter(b2, b2);
			
			var matrix:Array = new Array();
            matrix = matrix.concat([.3, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, .2, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, 0, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 2, 0]); // alpha
			var cmf:ColorMatrixFilter = new ColorMatrixFilter(matrix);
			
			__canvas.name = "canvas";
			addChild(__canvas);
			__canvas.blendMode = "overlay";
			__canvas.alpha = .1;
			
			__canvas2.filters = [f, blurF];
			__canvas2.name = "canvas2";
			addChild(__canvas2);
			__canvas2.blendMode = "screen";
			__canvas2.alpha = .25;
			__canvas.filters = [f, blurF, cmf];
			
			//this.blendMode = "overlay";
			//this.alpha = .01;
			
			if(__useMask){
				__grad = new Sprite();
				var fillType:String = GradientType.LINEAR;
				var colors:Array = [0xFF0000, 0x0000FF];
				var alphas:Array = [1, 0];
				var ratios:Array = [170, 255];
				var matr:Matrix = new Matrix();
				matr.createGradientBox(__width, __height, 0, 0, 0);
				var spreadMethod:String = SpreadMethod.PAD;
				__grad.graphics.beginFill(0xff0000, 0);
				__grad.graphics.drawRect(__width, 0, stage.stageWidth-__width, stage.stageHeight);
				__grad.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod);        
				__grad.graphics.drawRect(0, 0, __width, __height);
				__grad.graphics.endFill();
				
				addChild(__grad);
				__grad.blendMode = "alpha";
			}
			
			addEventListener(Event.ENTER_FRAME, update);
		}
		private function update(evt:Event):void{
			__displaceMatrix.translate(0, -SPEED/2);
			var fillType:String = "linear";
			var colors:Array = [0xFF0000, 0x0000FF];
			var alphas:Array = [1, 1];
			var ratios:Array = [0x00, 0xFF];
			var spreadMethod:String = "reflect";
			__displacementMap.graphics.clear();
			__displacementMap.graphics.beginGradientFill(fillType, colors, alphas, ratios, __displaceMatrix, spreadMethod);        
			__displacementMap.graphics.drawRect(0, 0, __width*2, __height);
			var dm:Matrix = new Matrix();
			dm.translate(-__width/4, 0);
			__displacementBmp.draw(__displacementMap, dm);
			
			__displacement2Map.graphics.clear();
			__displacement2Map.graphics.beginGradientFill(fillType, colors, alphas, ratios, __displaceMatrix, spreadMethod);        
			__displacement2Map.graphics.drawRect(0, 0, __width*2, __height);
			dm = new Matrix();
			dm.translate(-__height/4, 0);
			__displacement2Bmp.draw(__displacement2Map, dm);
			
			__canvasMatrix.translate(0, -SPEED);
			__canvas.graphics.clear();
			__canvas.graphics.beginBitmapFill(__perlinBmpData, __canvasMatrix, true, true);
			__canvas.graphics.drawRect(0, 0, __width, __height);
			__canvas.graphics.endFill();
			
			__canvas2Matrix.translate(SPEED, 0);
			__canvas2.graphics.clear();
			__canvas2.graphics.beginBitmapFill(__perlinBmpData, __canvas2Matrix, true, true);
			__canvas2.graphics.drawRect(0, 0, __width, __height);
			__canvas2.graphics.endFill();
			
			if(__dying){
				this.alpha = Math.max(0, this.alpha-.1);
				if(this.alpha == 0){
					rip();
				}
			}else{
				this.alpha = Math.min(2, this.alpha+.05);
			}
		}
		public function die():void{
			__dying = true;
		}
		
		
		private function rip():void{
			try{
				removeEventListener(Event.ENTER_FRAME, update);
			}catch(e:Error){}
			__displacementBmp.dispose();
			__perlinBmpData.dispose();
			
			__displacement2Bmp.dispose();
		}
	}
	
}
