﻿package com.axisstudios {
	import flash.display.MovieClip;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.events.Event;
	import flash.utils.getTimer;
	
	import com.greensock.TweenLite;
	import com.greensock.easing.RoughEase;
	import com.greensock.easing.Circ;
	
	import com.greensock.easing.Strong;
	import flash.geom.Rectangle;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.filters.BlurFilter;
	
	/**
	 * @author	Jeffrey Blyseth
	 * 			Axis Studios
	 * 			jeffrey@axis-studios.com
	 * 			http://www.axis-studios.com
	 */

	public class Slicer extends MovieClip {
		
		private static const BASE_SCALE:Number = 15;
		
		private var __tgt:MovieClip;
		private var __slices:uint;
		private var __scales:Array = [];
		private var __bitmapDatas:Array = [];
		private var __times:Array = [];
		private var __time:Number;
		private var __bmpData:BitmapData;
		private var __bmp:Bitmap;
		private var __stage:MovieClip;
		private var __startTime:Number;
		private var __baseBmpData:BitmapData;
		public var value:Number = 0;
		
		public function Slicer(tgt:MovieClip, slices:uint, time:Number, w:Number, h:Number):void{
			__tgt = tgt;
			__stage = MovieClip(tgt.parent);
			__slices = slices;
			__time = time;
			__bmpData = new BitmapData(w, h, true, 0x00000000);
			__bmp = new Bitmap(__bmpData, "auto", true);
			__tgt.alpha = 1;
			var baseBmpData:BitmapData = new BitmapData(w, h, true, 0x00000000);
			var mat:Matrix = new Matrix();
			//mat.translate(-tgt.x, tgt.y);
			baseBmpData.draw(tgt, mat);
			//var bb:Bitmap = new Bitmap(baseBmpData);
			//__stage.addChild(bb);
			
			var bw:Number = __tgt.width/__slices;
			var bh:Number = __tgt.height + 20;
			for(var i:uint=0;i<__slices;i++){
				var rect:Rectangle = new Rectangle(i*bw, tgt.y-10, bw, bh);
				var bmpData:BitmapData = new BitmapData(bw, bh, true, 0x00000000);
				bmpData.copyPixels( baseBmpData, rect, new Point( 0, 0 ) );
				__bitmapDatas.push(bmpData);
				//var b:Bitmap = new Bitmap(bmpData);
				//b.x = Math.random()*w;
				//b.y = Math.random()*h;
				//__stage.addChild(b);
			}
			//baseBmpData.dispose();
			__tgt.visible = false;
			for(i=0;i<slices;i++){
				__scales[i] = Math.random()*5 + BASE_SCALE;
				//__times[i] = i*(__time/slices)+10;
				__times[i] = Math.random()*__time/2 + __time/2;
			}
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		public function init(evt:Event):void{
			addChild(__bmp);
			__startTime = getTimer();
			TweenLite.to(this, __time/1000, {value:1, onUpdate:updateTween, onComplete:stopTween, ease:RoughEase.ease.config({strength:2, template:Circ.easeOut, taper:"in", clamp:true}) });
			//TweenLite.to(this, __time/1000, {onUpdate:updateTween, onComplete:stopTween, ease:Circ.easeIn} );
		}
		private function updateTween():void{
			//var tw:Array = TweenLite.getTweensOf(this);
			//var p:Number = tw[];
			var w:Number = __tgt.width/__slices;
			__bmpData.fillRect(__bmpData.rect, 0x00000000);
			__tgt.visible = true;
			//var pct:Number = (getTimer() - __startTime) / __time;
			var pct:Number = value;
			var b:Number = Math.max(0, (1-pct)*300);
			var blur:BlurFilter = new BlurFilter(b, b*.15);
			this.filters = [blur];
			for(var i:uint=0;i<__slices;i++){
				pct = value;//(getTimer() - __startTime) / __times[i];
				var mat:Matrix = new Matrix();
				var s:Number = Math.max(1, __scales[i]-((__scales[i])*pct));
				mat.scale(s, s);
				var offsetX:Number = -(__bitmapDatas[i].width*s - __bitmapDatas[i].width) / 2;
				var offsetY:Number = -(__bitmapDatas[i].height*s - __bitmapDatas[i].height) / 2;
				mat.translate(__tgt.x + offsetX + w*i, __tgt.y + offsetY);
				__bmpData.draw(__bitmapDatas[i], mat);
				//__bmpData.copyPixels(__bitmapDatas[i], BitmapData(__bitmapDatas[i]).rect, new Point( w*i, 0 ) );
			}

			__tgt.visible = false;
		}
		private function stopTween():void{
			TweenLite.killTweensOf(this);
			__tgt.visible = true;
			for(var i:uint=0;i<__slices;i++){
				BitmapData(__bitmapDatas[i]).dispose();
			}
			__bmpData.dispose();
			__bitmapDatas = [];
			__scales = [];
			__times = [];
			dispatchEvent(new Event("slicerDoneEvent", true, false));
		}
	}
}




